/*
"This product may only be used by licensed owners of the Blitz3D
SDK."
*/
#autodefine "off"
#use "b3d.lib"
#define BBFALSE 0
#define BBTRUE 1

#define GFX_DEFAULT 0
#define GFX_FULLSCREEN 1
#define GFX_WINDOWED 2
#define GFX_WINDOWEDSCALED 3

#define PROJ_NONE 0
#define PROJ_PERSPECTIVE 1
#define PROJ_ORTHO 2

#define LIGHTDIRECTIONAL 1
#define LIGHTPOINT 2
#define LIGHTSPOT 3

#define TX_COLOR 1
#define TX_ALPHA 2
#define TX_MASKED 4
#define TX_MIP 8
#define TX_CLAMPU 16
#define TX_CLAMPV 32
#define TX_SPHERE 64
#define TX_CUBIC 128
#define TX_VRAM 256
#define TX_HIGHCOLOR 512

#define TX_BLEND_NONE 0
#define TX_BLEND_ALPHA 1
#define TX_BLEND_MULT 2
#define TX_BLEND_ADD 3
#define TX_BLEND_DOT3 4
#define TX_BLEND_MULT2 5

#define CUBEFACE_LEFT 0
#define CUBEFACE_FRONT 1
#define CUBEFACE_RIGHT 2
#define CUBEFACE_BACK 3
#define CUBEFACE_TOP 4
#define CUBEFACE_BOTTOM 5

#define CUBEMODE_SPECULAR 1
#define CUBEMODE_DIFFUSE 2
#define CUBEMODE_REFRACTION 3

#define BRUSHBLEND_NONE 0
#define BRUSHBLEND_MULTIPLY 1
#define BRUSHBLEND_ALPHA 2
#define BRUSHBLEND_ADD 3

#define BRUSHFX_NONE 0
#define BRUSHFX_FULLBRIGHT 1
#define BRUSHFX_VERTEXCOLOR 2
#define BRUSHFX_FLAT 4
#define BRUSHFX_NOFOG 8
#define BRUSHFX_DOUBLESIDED 16
#define BRUSHFX_VERTEXALPHA 32

#define COLLIDE_SPHERESPHERE 1
#define COLLIDE_SPHEREPOLY 2
#define COLLIDE_SPHEREBOX 3

#define COLLIDE_STOP 1
#define COLLIDE_SLIDE1 2
#define COLLIDE_SLIDE2 3

#define PICK_NONE 0
#define PICK_SPHERE 1
#define PICK_POLY 2
#define PICK_BOX 3

#define ANIMSTOP 0
#define ANIMLOOP 1
#define ANIMPINGPONG 2
#define ANIMONCE 3

#define SPRITE_TURNXY 1
#define SPRITE_STILL 2
#define SPRITE_ALIGNZ 3
#define SPRITE_TURNY 4

#define PLAYCD_SINGLE 1
#define PLAYCD_LOOP 2
#define PLAYCD_ALL 3

#define MOUSE_BUTTON 1
#define MOUSE_RIGHTBUTTON 2
#define MOUSE_MIDDLEBUTTON 3

#define JOYTYPE_NONE 0
#define JOYTYPE_DIGITAL 1 
#define JOYTYPE_ANALOG 2

#define KEY_ESCAPE 1
#define KEY_TAB 15
#define KEY_SPACE 57
#define KEY_RETURN 28
#define KEY_LEFTSHIFT 42
#define KEY_LEFTCONTROL 29
#define KEY_LEFTALT 56
#define KEY_RIGHTSHIFT 54
#define KEY_RIGHTCONTROL 157
#define KEY_RIGHTALT 184
 
#define KEY_UP 200
#define KEY_LEFT 203
#define KEY_RIGHT 205
#define KEY_DOWN 208
 
#define KEY_F1 59
#define KEY_F2 60 
#define KEY_F3 61
#define KEY_F4 62
#define KEY_F5 63
#define KEY_F6 64
#define KEY_F7 65
#define KEY_F8 66
#define KEY_F9 67
#define KEY_F10 68

#define KEY_Q 16
#define KEY_W 17
#define KEY_E 18
#define KEY_R 19
#define KEY_T 20 
#define KEY_Y 21
#define KEY_U 22
#define KEY_I 23
#define KEY_O 24
#define KEY_P 25
 
#define KEY_A 30 
#define KEY_S 31
#define KEY_D 32
#define KEY_F 33
#define KEY_G 34
#define KEY_H 35
#define KEY_J 36
#define KEY_K 37
#define KEY_L 38
 
#define KEY_Z 44
#define KEY_X 45
#define KEY_C 46
#define KEY_V 47
#define KEY_B 48
#define KEY_N 49
#define KEY_M 50 
 
#define KEY_1 2
#define KEY_2 3
#define KEY_3 4
#define KEY_4 5
#define KEY_5 6
#define KEY_6 7
#define KEY_7 8
#define KEY_8 9
#define KEY_9 10 
#define KEY_0 11

#define KEY_MINUS 12
#define KEY_EQUALS 13
#define KEY_BACKSPACE 14
#define KEY_LEFTBRACKET 26
#define KEY_RIGHTBRACKET 27
#define KEY_SEMICOLON 39
#define KEY_APOSTROPHE 40 
#define KEY_GRAVE 41
#define KEY_BACKSLASH 43
#define KEY_COMMA 51
#define KEY_PERIOD 52
#define KEY_SLASH 53
#define KEY_CAPSLOCK 58
 
#define KEY_PRINT 183
#define KEY_SCROLLLOCK 70 
#define KEY_PAUSEBREAK 197
#define KEY_INSERT 210
#define KEY_DELETE 211
#define KEY_HOME 199
#define KEY_END 207
#define KEY_PAGEUP 201
#define KEY_PAGEDOWN 209

#define KEY_NUMLOCK 69
#define KEY_NUMPADDIVIDE 181
#define KEY_NUMPADMULT 55
#define KEY_NUMPADMINUS 74
#define KEY_NUMPADPLUS 78
#define KEY_NUMPADENTER 156
#define KEY_NUMPADDOT 83
#define KEY_NUMPAD0 82
#define KEY_NUMPAD1 79
#define KEY_NUMPAD2 80 
#define KEY_NUMPAD3 81
#define KEY_NUMPAD4 75
#define KEY_NUMPAD5 76
#define KEY_NUMPAD6 77
#define KEY_NUMPAD7 71
#define KEY_NUMPAD8 72
#define KEY_NUMPAD9 73

#define KEY_F11 87
#define KEY_F12 88
#define KEY_LEFTWINDOWS 219
#define KEY_RIGHTWINDOWS 220
#define KEY_NUMPADEQUALS 141
#define KEY_NUMPADCOMMA 179
#define KEY_OEM_102 86
#define KEY_AT 145
#define KEY_COLON 146
#define KEY_UNDERLINE 147
#define KEY_BREAK 149

#define KEY_PREVIOUSTRACK 144
#define KEY_NEXTTRACK 153
#define KEY_MUTE 160
#define KEY_PLAYPAUSE 162
#define KEY_STOP 164
#define KEY_VOLUMELESS 174
#define KEY_VOLUMEMORE 176
 
#define KEY_APPS 221
#define KEY_POWER 222
#define KEY_SLEEP 223
#define KEY_WAKE 227

#define KEY_WEBHOME 178
#define KEY_WEBSEARCH 229
#define KEY_WEBFAVORITES 230 
#define KEY_WEBREFRESH 231
#define KEY_WEBSTOP 232
#define KEY_WEBFORWARD 233
#define KEY_WEBBACK 234
 
#define KEY_MYCOMPUTER 235
#define KEY_CALCULATOR 161
#define KEY_MAIL 236
#define KEY_MEDIASELECT 237

//typedef void * BBObject;
#typedef BBObject int;

#typedef BBTimer BBObject;
#typedef BBSound BBObject;
#typedef BBChannel BBObject; 

#typedef BBGraphics BBObject; 
#typedef BBImage BBObject;
#typedef BBMovie BBObject;
#typedef BBFont BBObject;
#typedef BBCanvas BBObject;
#typedef BBScene BBObject;

#typedef BBLight BBObject;
#typedef BBCamera BBObject;
#typedef BBModel BBObject;
#typedef BBEntity BBObject;
#typedef BBSurface BBObject;
#typedef BBTexture BBObject;
#typedef BBBrush BBObject;
#typedef BBPivot BBObject;
#typedef BBSprite BBObject;
#typedef BBPlaneModel BBObject;
#typedef BBMeshModel BBObject;
#typedef BBQ3BSPModel BBObject;
#typedef BBMD2Model BBObject;
#typedef BBMirror BBObject;
#typedef BBTerrain BBObject;

#typedef UINT unsigned int;
#typedef HWND UINT;
#typedef HANDLE UINT;
#typedef BOOL int;
#typedef char byte;

//bbruntime

DECLARE CDECL import,bbVersion(),int;

DECLARE CDECL import,bbSetBlitz3DDebugMode(int debugmode);
DECLARE CDECL import,bbSetBlitz3DDebugCallback(int sub_b3dDebugCallback);
declare cdecl b3dDebugCallback(string *message); // custom function name
DECLARE CDECL import,bbSetBlitz3DEventCallback(int sub_b3dEventCallback);
declare cdecl b3dEventCallback(int hwnd,int msg,int wparam,int lparam),int; // custom function name

DECLARE CDECL import,bbSetBlitz3DHWND(int hwndparent);
DECLARE CDECL import,bbSetBlitz3DTitle(char *title,char *close);

DECLARE CDECL import,bbBeginBlitz3D(),int;
DECLARE CDECL import,bbEndBlitz3D();

DECLARE CDECL import,bbRuntimeError(char *p);
DECLARE CDECL import,bbSystemProperty(char *name),char*;

DECLARE CDECL import,bbMilliSecs(),int;

DECLARE CDECL import,bbDelay( int ms );
DECLARE CDECL import,bbShowPointer();
DECLARE CDECL import,bbHidePointer();

DECLARE CDECL import,bbCreateTimer( int hz ),BBTimer;
DECLARE CDECL import,bbFreeTimer(BBTimer timer);
DECLARE CDECL import,bbWaitTimer(BBTimer timer);

// bbinput

//keyboard
DECLARE CDECL import,bbKeyDown( int n ),int;
DECLARE CDECL import,bbKeyHit( int n ),int;
DECLARE CDECL import,bbGetKey(),int;
DECLARE CDECL import,bbWaitKey(),int;
DECLARE CDECL import,bbFlushKeys();

//mouse
DECLARE CDECL import,bbMouseDown( int n ),int;
DECLARE CDECL import,bbMouseHit( int n ),int;
DECLARE CDECL import,bbGetMouse(),int;
DECLARE CDECL import,bbWaitMouse(),int;
DECLARE CDECL import,bbMouseX(),int;
DECLARE CDECL import,bbMouseY(),int;
DECLARE CDECL import,bbMouseZ(),int;
DECLARE CDECL import,bbMouseXSpeed(),int;
DECLARE CDECL import,bbMouseYSpeed(),int;
DECLARE CDECL import,bbMouseZSpeed(),int;
DECLARE CDECL import,bbMoveMouse( int x,int y );
DECLARE CDECL import,bbFlushMouse();


DECLARE CDECL import,bbJoyType(OPT int port=0 ),int;
DECLARE CDECL import,bbJoyDown( int n,OPT int port=0 ),int;
DECLARE CDECL import,bbJoyHit( int n,OPT int port=0 ),int;
DECLARE CDECL import,bbGetJoy( OPT int port=0 ),int;
DECLARE CDECL import,bbWaitJoy( OPT int port=0 ),int;
DECLARE CDECL import,bbJoyX( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyY( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyZ( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyU( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyV( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyPitch( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyYaw( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyRoll( OPT int port=0 ),float;
DECLARE CDECL import,bbJoyHat( OPT int port=0 ),int;
DECLARE CDECL import,bbJoyXDir( OPT int port=0 ),int;
DECLARE CDECL import,bbJoyYDir( OPT int port=0 ),int;
DECLARE CDECL import,bbJoyZDir( OPT int port=0 ),int;
DECLARE CDECL import,bbJoyUDir( OPT int port=0 ),int;
DECLARE CDECL import,bbJoyVDir( OPT int port=0 ),int;

DECLARE CDECL import,bbFlushJoy();

// bbaudio


DECLARE CDECL import,bbLoadSound( char *src,OPT int flags=0 ),BBSound;

DECLARE CDECL import,bbFreeSound( BBSound sound );
DECLARE CDECL import,bbPlaySound( BBSound sound ),BBChannel;
DECLARE CDECL import,bbLoopSound( BBSound sound );
DECLARE CDECL import,bbSoundPitch( BBSound sound,int pitch );
DECLARE CDECL import,bbSoundVolume( BBSound sound,float volume );
DECLARE CDECL import,bbSoundPan( BBSound sound,float pan );

DECLARE CDECL import,bbPlayMusic( char *src,OPT int mode=1 ),BBChannel;
DECLARE CDECL import,bbPlayCDTrack( int track,OPT int mode=1 ),BBChannel;

DECLARE CDECL import,bbStopChannel( BBChannel channel );
DECLARE CDECL import,bbPauseChannel( BBChannel channel );
DECLARE CDECL import,bbResumeChannel( BBChannel channel );
DECLARE CDECL import,bbChannelPitch( BBChannel channel,int pitch );
DECLARE CDECL import,bbChannelVolume( BBChannel channel,float volume );
DECLARE CDECL import,bbChannelPan( BBChannel channel,float pan );
DECLARE CDECL import,bbChannelPlaying( BBChannel channel ),int;

// bbgraphics
DECLARE CDECL import,bbGraphics3D( int w,int h,OPT int d=0,OPT int mode=0 );

DECLARE CDECL import,bbCountGfxDrivers(),int;
DECLARE CDECL import,bbGfxDriverName( int n ),char*;
DECLARE CDECL import,bbGfxDriver3D( int n ),int;

DECLARE CDECL import,bbGfxDriverCaps3D(),int;

DECLARE CDECL import,bbCountGfxModes3D(),int;
DECLARE CDECL import,bbGfxMode3DExists( int w,int h,int d ),int;
DECLARE CDECL import,bbGfxMode3D( int n ),int;
DECLARE CDECL import,bbWindowed3D(),int;

DECLARE CDECL import,bbGfxDriverX( int n ),int;
DECLARE CDECL import,bbGfxDriverY( int n ),int;
DECLARE CDECL import,bbGfxDriverHz( int n ),int;

DECLARE CDECL import,bbSetGfxDriver( int n );
DECLARE CDECL import,bbGfxModeExists( int w,int h,int d ),int;
DECLARE CDECL import,bbCountGfxModes(),int;

DECLARE CDECL import,bbGfxModeWidth( int n ),int;
DECLARE CDECL import,bbGfxModeHeight( int n ),int;
DECLARE CDECL import,bbGfxModeDepth( int n ),int;

DECLARE CDECL import,bbGraphicsWidth(),int;
DECLARE CDECL import,bbGraphicsHeight(),int;
DECLARE CDECL import,bbGraphicsDepth(),int;

DECLARE CDECL import,bbAvailVidMem(),int;
DECLARE CDECL import,bbTotalVidMem(),int;

//mode functions

DECLARE CDECL import,bbGraphics( int w,int h,int d,int mode );
DECLARE CDECL import,bbFrontBuffer(),BBCanvas;
DECLARE CDECL import,bbBackBuffer(),BBCanvas;
DECLARE CDECL import,bbGraphicsLost(),int;
DECLARE CDECL import,bbEndGraphics();
DECLARE CDECL import,bbScanLine(),int;
DECLARE CDECL import,bbVWait( int n );

DECLARE CDECL import,bbFlip(OPT int vwait=1 );

DECLARE CDECL import,bbPaint( int hwnd );

//graphics buffer functions

DECLARE CDECL import,bbSetBuffer(BBCanvas buff);
DECLARE CDECL import,bbGraphicsBuffer(),BBCanvas;
DECLARE CDECL import,bbLoadBuffer(BBCanvas surf, char *str),int;
DECLARE CDECL import,bbSaveBuffer(BBCanvas surf, char *str),int;
DECLARE CDECL import,bbBufferDirty(BBCanvas buffer);
DECLARE CDECL import,bbAutoBufferDirty(int enable);

//fast read/write operations...

DECLARE CDECL import,bbLockBuffer( BBCanvas buff );
DECLARE CDECL import,bbUnlockBuffer( BBCanvas buff );
DECLARE CDECL import,bbReadPixel( int x,int y,BBCanvas buff ),int;
DECLARE CDECL import,bbWritePixel( int x,int y,int argb,BBCanvas buff );
DECLARE CDECL import,bbReadPixelFast( int x,int y,BBCanvas buff ),int;
DECLARE CDECL import,bbWritePixelFast( int x,int y,int argb,BBCanvas buff );
DECLARE CDECL import,bbCopyPixel( int src_x,int src_y,BBCanvas src,int dest_x,int dest_y,BBCanvas buff );
DECLARE CDECL import,bbCopyPixelFast( int src_x,int src_y,BBCanvas src,int dest_x,int dest_y,BBCanvas buff );

//2d rendering functions

DECLARE CDECL import,bbOrigin( int x,int y );
DECLARE CDECL import,bbViewport( int x,int y,int w,int h );
DECLARE CDECL import,bbColor( int r,int g,int b );
DECLARE CDECL import,bbClsColor( int r,int g,int b );
DECLARE CDECL import,bbCls();
DECLARE CDECL import,bbPlot( int x,int y );
DECLARE CDECL import,bbLine( int x1,int y1,int x2,int y2 );

DECLARE CDECL import,bbRect( int x,int y,int w,int h,OPT int solid=1 );
DECLARE CDECL import,bbOval( int x,int y,int w,int h,OPT int solid=1 );
DECLARE CDECL import,bbText( int x,int y, char *t,OPT int centre_x=0,OPT int centre_y=0 );

DECLARE CDECL import,bbCopyRect( int sx,int sy,int w,int h,int dx,int dy,BBCanvas src,BBCanvas dest );
DECLARE CDECL import,bbGetColor( int x,int y );
DECLARE CDECL import,bbColorRed(),int;
DECLARE CDECL import,bbColorGreen(),int;
DECLARE CDECL import,bbColorBlue(),int;

//font functions

DECLARE CDECL import,bbLoadFont(  char *name,int height,int bold,int italic,int underline ),BBFont;
DECLARE CDECL import,bbFreeFont( BBFont f );
DECLARE CDECL import,bbSetFont( BBFont f );
DECLARE CDECL import,bbFontWidth(),int;
DECLARE CDECL import,bbFontHeight(),int;
DECLARE CDECL import,bbStringWidth(  char *str ),int;
DECLARE CDECL import,bbStringHeight(  char *str ),int;

//image functions

DECLARE CDECL import,bbLoadImage(  char *s ),BBImage;
DECLARE CDECL import,bbCopyImage( BBImage sourceimage ),BBImage;
DECLARE CDECL import,bbCreateImage( int w,int h,int n ),BBImage;
DECLARE CDECL import,bbLoadAnimImage(  char *s,int w,int h,int first,int cnt ),BBImage;
DECLARE CDECL import,bbFreeImage( BBImage i );
DECLARE CDECL import,bbSaveImage( BBImage i, char *filename,int frame ),int;
DECLARE CDECL import,bbGrabImage( BBImage i,int x,int y,int n );
DECLARE CDECL import,bbImageBuffer( BBImage i,int n ),BBCanvas;
DECLARE CDECL import,bbDrawImage( BBImage i,int x,int y,int frame );
DECLARE CDECL import,bbDrawBlock( BBImage i,int x,int y,int frame );
DECLARE CDECL import,bbTileImage( BBImage i,int x,int y,int frame );
DECLARE CDECL import,bbTileBlock( BBImage i,int x,int y,int frame );
DECLARE CDECL import,bbDrawImageRect( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h,int frame );
DECLARE CDECL import,bbDrawBlockRect( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h,int frame );
DECLARE CDECL import,bbMaskImage( BBImage i,int r,int g,int b );
DECLARE CDECL import,bbHandleImage( BBImage i,int x,int y );
DECLARE CDECL import,bbScaleImage( BBImage i,float w,float h );
DECLARE CDECL import,bbResizeImage( BBImage i,float w,float h );
DECLARE CDECL import,bbRotateImage( BBImage i,float angle );
DECLARE CDECL import,bbTFormImage( BBImage i,float a,float b,float c,float d );
DECLARE CDECL import,bbTFormFilter( int enable );
DECLARE CDECL import,bbAutoMidHandle( int enable );
DECLARE CDECL import,bbMidHandle( BBImage i );
DECLARE CDECL import,bbImageWidth( BBImage i ),int;
DECLARE CDECL import,bbImageHeight( BBImage i ),int;
DECLARE CDECL import,bbImageXHandle( BBImage i ),int;
DECLARE CDECL import,bbImageYHandle( BBImage i ),int;
DECLARE CDECL import,bbImagesOverlap( BBImage i1,int x1,int y1,BBImage i2,int x2,int y2 ),int;
DECLARE CDECL import,bbImagesCollide( BBImage i1,int x1,int y1,int f1,BBImage i2,int x2,int y2,int f2 ),int;
DECLARE CDECL import,bbRectsOverlap( int x1,int y1,int w1,int h1,int x2,int y2,int w2,int h2 ),int;
DECLARE CDECL import,bbImageRectOverlap( BBImage i,int x,int y,int r_x,int r_y,int r_w,int r_h ),int;
DECLARE CDECL import,bbImageRectCollide( BBImage i,int x,int y,int f,int r_x,int r_y,int r_w,int r_h ),int;

DECLARE CDECL import,bbWrite(  char *str );
DECLARE CDECL import,bbPrint(  char *str );
DECLARE CDECL import,bbInput(  char *prompt ),char*;
DECLARE CDECL import,bbLocate( int x,int y );

// movie commands

DECLARE CDECL import,bbOpenMovie(  char *s ),BBMovie;
DECLARE CDECL import,bbDrawMovie( BBMovie movie,int x,int y,int w,int h ),int;
DECLARE CDECL import,bbMovieWidth( BBMovie movie ),int;
DECLARE CDECL import,bbMovieHeight( BBMovie movie ),int;
DECLARE CDECL import,bbMoviePlaying( BBMovie movie ),int;
DECLARE CDECL import,bbCloseMovie( BBMovie movie );

// gamma commands

DECLARE CDECL import,bbSetGamma( int r,int g,int b,float dr,float dg,float db );
DECLARE CDECL import,bbUpdateGamma( int calibrate );
DECLARE CDECL import,bbGammaRed( int n ),float;
DECLARE CDECL import,bbGammaGreen( int n ),float;
DECLARE CDECL import,bbGammaBlue( int n ),float;

// bbgraphics3d

// global world commands 

DECLARE CDECL import,bbLoaderMatrix(  char *ext,float xx,float xy,float xz,float yx,float yy,float yz,float zx,float zy,float zz );
DECLARE CDECL import,bbHWTexUnits(),int;

DECLARE CDECL import,bbHWMultiTex( int enable );
DECLARE CDECL import,bbWBuffer( int enable );
DECLARE CDECL import,bbDither( int enable );
DECLARE CDECL import,bbAntiAlias( int enable );
DECLARE CDECL import,bbWireFrame( int enable );
DECLARE CDECL import,bbAmbientLight( float r,float g,float b );
DECLARE CDECL import,bbClearCollisions();

DECLARE CDECL import,bbCollisions( int src_type,int dest_type,int method,int response );

DECLARE CDECL import,bbUpdateWorld( OPT float elapsed=1.0f );
DECLARE CDECL import,bbRenderWorld( OPT float tween=1.0f );

DECLARE CDECL import,bbCaptureWorld();
DECLARE CDECL import,bbTrisRendered(),int;
DECLARE CDECL import,bbStats3D( int n ),float;

// texture commands

DECLARE CDECL import,bbLoadTexture(  char *file,OPT int flags=1 ),BBTexture;
DECLARE CDECL import,bbCreateTexture( int w,int h,OPT int flags=3,OPT int frames=1 ),BBTexture;

DECLARE CDECL import,bbLoadAnimTexture(  char *file,int flags,int w,int h,int first,int cnt ),BBTexture;
DECLARE CDECL import,bbFreeTexture( BBTexture t );
DECLARE CDECL import,bbTextureBlend( BBTexture t,int blend );
DECLARE CDECL import,bbTextureCoords( BBTexture t,int flags );
DECLARE CDECL import,bbScaleTexture( BBTexture t,float u_scale,float v_scale );
DECLARE CDECL import,bbRotateTexture( BBTexture t,float angle );
DECLARE CDECL import,bbPositionTexture( BBTexture t,float u_pos,float v_pos );
DECLARE CDECL import,bbTextureWidth( BBTexture t ),int;
DECLARE CDECL import,bbTextureHeight( BBTexture t ),int;

DECLARE CDECL import,bbTextureName( BBTexture t ),char*;
DECLARE CDECL import,bbSetCubeFace( BBTexture t,int face );
DECLARE CDECL import,bbSetCubeMode( BBTexture t,int mode );

DECLARE CDECL import,bbTextureBuffer( BBTexture t,OPT int frame=0 ),BBCanvas ;

DECLARE CDECL import,bbClearTextureFilters();
DECLARE CDECL import,bbTextureFilter(char *t,int flags );

// brush commands


DECLARE CDECL import,bbCreateBrush( OPT float r=255.0f,OPT float g=255.0f,OPT float b=255.0f ),BBBrush;
DECLARE CDECL import,bbLoadBrush(char *file,OPT int flags=1,OPT float u_scale=1.0f,OPT float v_scale=1.0f ),BBBrush;

DECLARE CDECL import,bbFreeBrush( BBBrush b );
DECLARE CDECL import,bbBrushColor( BBBrush br,float r,float g,float b );
DECLARE CDECL import,bbBrushAlpha( BBBrush b,float alpha );
DECLARE CDECL import,bbBrushShininess( BBBrush b,float n );
DECLARE CDECL import,bbBrushTexture( BBBrush b,BBTexture t,int frame,int index );
DECLARE CDECL import,bbGetBrushTexture( BBBrush b,int index ),BBTexture;
DECLARE CDECL import,bbBrushBlend( BBBrush b,int blend );
DECLARE CDECL import,bbBrushFX( BBBrush b,int fx );

// mesh commands

DECLARE CDECL import,bbCreateMesh( OPT BBEntity p=0 ),BBModel;
DECLARE CDECL import,bbLoadMesh(  char *f,OPT BBEntity p=0 ),BBModel;
DECLARE CDECL import,bbLoadAnimMesh(  char *f,OPT BBEntity p=0 ),BBModel;
DECLARE CDECL import,bbCreateCube( OPT BBEntity p=0 ),BBModel;
DECLARE CDECL import,bbCreateSphere( OPT int segs=8,OPT BBEntity p=0 ),BBModel;
DECLARE CDECL import,bbCreateCylinder( OPT int segs=8,OPT int solid=1,OPT BBEntity p=0 ),BBModel;
DECLARE CDECL import,bbCreateCone( OPT int segs=8,OPT int solid=1,OPT BBEntity p=0 ),BBModel;
DECLARE CDECL import,bbCopyMesh( BBModel m,OPT BBEntity p=0 ),BBModel;

DECLARE CDECL import,bbScaleMesh( BBModel m,float x,float y,float z );
DECLARE CDECL import,bbRotateMesh( BBModel m,float x,float y,float z );
DECLARE CDECL import,bbPositionMesh( BBModel m,float x,float y,float z );

DECLARE CDECL import,bbFitMesh( BBModel m,float x,float y,float z,float w,float h,float d,OPT int uniform=0 );

DECLARE CDECL import,bbFlipMesh( BBModel m );
DECLARE CDECL import,bbPaintMesh( BBModel m,BBBrush b );
DECLARE CDECL import,bbAddMesh( BBModel src,BBModel dest );
DECLARE CDECL import,bbUpdateNormals( BBModel m );
DECLARE CDECL import,bbLightMesh( BBModel m,float r,float g,float b,float range,float x,float y,float z );
DECLARE CDECL import,bbMeshWidth( BBModel m ),float;
DECLARE CDECL import,bbMeshHeight( BBModel m ),float;
DECLARE CDECL import,bbMeshDepth( BBModel m ),float;
DECLARE CDECL import,bbMeshesIntersect( BBModel a,BBModel b ),int;
DECLARE CDECL import,bbCountSurfaces( BBModel m ),int;
DECLARE CDECL import,bbGetSurface( BBModel m,int index ),BBSurface;
DECLARE CDECL import,bbMeshCullBox( BBModel m,float x,float y,float z,float w,float h,float d );

// surface commands

DECLARE CDECL import,bbCreateSurface( BBModel m,OPT BBBrush b=0 ),BBSurface;

DECLARE CDECL import,bbFindSurface( BBModel m,BBBrush b ),BBSurface;
DECLARE CDECL import,bbGetSurfaceBrush( BBSurface s ),BBBrush;
DECLARE CDECL import,bbGetEntityBrush( BBModel m ),BBBrush;

DECLARE CDECL import,bbClearSurface( BBSurface s,int verts,int tris );
DECLARE CDECL import,bbPaintSurface( BBSurface s,BBBrush b );

DECLARE CDECL import,bbAddVertex( BBSurface s,float x,float y,float z,OPT float tu=0.0f,OPT float tv=0.0f,OPT float tw=0.0f ),int;

DECLARE CDECL import,bbAddTriangle( BBSurface s,int v0,int v1,int v2 ),int;
DECLARE CDECL import,bbVertexCoords( BBSurface s,int n,float x,float y,float z );
DECLARE CDECL import,bbVertexNormal( BBSurface s,int n,float x,float y,float z );

DECLARE CDECL import,bbVertexColor( BBSurface s,int n,float r,float g,float b,float a );
DECLARE CDECL import,bbVertexTexCoords( BBSurface s,int n,float u,float v,float w,int set );
DECLARE CDECL import,bbCountVertices( BBSurface s ),int;
DECLARE CDECL import,bbCountTriangles( BBSurface s ),int;
DECLARE CDECL import,bbVertexX( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexY( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexZ( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexNX( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexNY( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexNZ( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexRed( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexGreen( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexBlue( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexAlpha( BBSurface s,int n ),float;
DECLARE CDECL import,bbVertexU( BBSurface s,int n,int t ),float;
DECLARE CDECL import,bbVertexV( BBSurface s,int n,int t ),float;
DECLARE CDECL import,bbVertexW( BBSurface s,int n,int t ),float;
DECLARE CDECL import,bbTriangleVertex( BBSurface s,int n,int v ),int;

// camera commands

DECLARE CDECL import,bbCreateCamera( OPT BBEntity p=0 ),BBCamera;

DECLARE CDECL import,bbCameraZoom( BBCamera c,float zoom );
DECLARE CDECL import,bbCameraRange( BBCamera c,float nr,float fr );
DECLARE CDECL import,bbCameraClsColor( BBCamera c,float r,float g,float b );
DECLARE CDECL import,bbCameraClsMode( BBCamera c,int cls_color,int cls_zbuffer );
DECLARE CDECL import,bbCameraProjMode( BBCamera c,int mode );
DECLARE CDECL import,bbCameraViewport( BBCamera c,int x,int y,int w,int h );
DECLARE CDECL import,bbCameraFogRange( BBCamera c,float nr,float fr );
DECLARE CDECL import,bbCameraFogColor( BBCamera c,float r,float g,float b );
DECLARE CDECL import,bbCameraFogMode( BBCamera c,int mode );
DECLARE CDECL import,bbCameraProject( BBCamera c,float x,float y,float z ),int;
DECLARE CDECL import,bbProjectedX(),float;
DECLARE CDECL import,bbProjectedY(),float;
DECLARE CDECL import,bbProjectedZ(),float;
DECLARE CDECL import,bbCameraPick( BBCamera c,float x,float y ),BBEntity;
DECLARE CDECL import,bbLinePick( float x,float y,float z,float dx,float dy,float dz,float radius ),BBEntity;
DECLARE CDECL import,bbEntityPick( BBObject src,float range ),BBEntity;
DECLARE CDECL import,bbEntityVisible( BBObject src,BBObject dest ),int;
DECLARE CDECL import,bbEntityInView( BBEntity e,BBCamera c ),int;
DECLARE CDECL import,bbPickedX(),float;
DECLARE CDECL import,bbPickedY(),float;
DECLARE CDECL import,bbPickedZ(),float;
DECLARE CDECL import,bbPickedNX(),float;
DECLARE CDECL import,bbPickedNY(),float;
DECLARE CDECL import,bbPickedNZ(),float;
DECLARE CDECL import,bbPickedTime(),float;
DECLARE CDECL import,bbPickedEntity(),BBObject;
DECLARE CDECL import,bbPickedSurface(),BBSurface;
DECLARE CDECL import,bbPickedTriangle(),int;

// light commands

DECLARE CDECL import,bbCreateLight( OPT int type=0,OPT BBEntity p=0 ),BBLight;

DECLARE CDECL import,bbLightColor( BBLight light,float r,float g,float b );
DECLARE CDECL import,bbLightRange( BBLight light,float range );
DECLARE CDECL import,bbLightConeAngles( BBLight light,float inner,float outer );

// pivot commands
DECLARE CDECL import,bbCreatePivot( OPT BBEntity p=0 ),BBPivot;

// sprite commands

DECLARE CDECL import,bbCreateSprite( OPT BBEntity p=0 ),BBSprite;
DECLARE CDECL import,bbLoadSprite(  char *file,OPT int flags=1,OPT BBEntity p=0 ),BBSprite;

DECLARE CDECL import,bbRotateSprite( BBSprite s,float angle );
DECLARE CDECL import,bbScaleSprite( BBSprite s,float x,float y );
DECLARE CDECL import,bbHandleSprite( BBSprite s,float x,float y );
DECLARE CDECL import,bbSpriteViewMode( BBSprite s,int mode );

// mirror commands

DECLARE CDECL import,bbCreateMirror( OPT BBEntity p=0 ),BBMirror;


// plane commands

DECLARE CDECL import,bbCreatePlane( OPT int segs=1,OPT BBEntity p=0 ),BBPlaneModel;


// md2 commands

DECLARE CDECL import,bbLoadMD2( char *file,OPT BBEntity p=0 ),BBMD2Model;
DECLARE CDECL import,bbAnimateMD2( BBMD2Model m,OPT int mode=1,OPT float speed=1.0f,OPT int first=0,OPT int last=9999,OPT float trans=0.0f );

DECLARE CDECL import,bbMD2AnimTime( BBMD2Model m ),float;
DECLARE CDECL import,bbMD2AnimLength( BBMD2Model m ),int;
DECLARE CDECL import,bbMD2Animating( BBMD2Model m ),int;

// bsp commands

DECLARE CDECL import,bbLoadBSP(char *file,float gam,OPT BBEntity p=0 ),BBQ3BSPModel;

DECLARE CDECL import,bbBSPAmbientLight( BBQ3BSPModel t,float r,float g,float b );
DECLARE CDECL import,bbBSPLighting( BBQ3BSPModel t,int lmap );

// terrain commands

DECLARE CDECL import,bbCreateTerrain( int n,OPT BBEntity p=0 ),BBTerrain;
DECLARE CDECL import,bbLoadTerrain(char *file,OPT BBEntity p=0 ),BBTerrain;

DECLARE CDECL import,bbTerrainDetail( BBTerrain t,int n,int m );
DECLARE CDECL import,bbTerrainShading( BBTerrain t,int enable );
DECLARE CDECL import,bbTerrainX( BBTerrain t,float x,float y,float z ),float;
DECLARE CDECL import,bbTerrainY( BBTerrain t,float x,float y,float z ),float;
DECLARE CDECL import,bbTerrainZ( BBTerrain t,float x,float y,float z ),float;
DECLARE CDECL import,bbTerrainSize( BBTerrain t ),int;
DECLARE CDECL import,bbTerrainHeight( BBTerrain t,int x,int z ),float;
DECLARE CDECL import,bbModifyTerrain( BBTerrain t,int x,int z,float h,int realtime );

// audio commands

DECLARE CDECL import,bbCreateListener( OPT BBEntity p=0,OPT float roll=1.0f,OPT float dopp=1.0f,OPT float dist=1.0f ),BBEntity;

DECLARE CDECL import,bbEmitSound( BBSound sound,BBObject o ),BBChannel;

// entity commands

DECLARE CDECL import,bbCopyEntity( BBEntity e,OPT BBEntity p=0 ),BBEntity;

DECLARE CDECL import,bbFreeEntity( BBEntity e );
DECLARE CDECL import,bbHideEntity( BBEntity e );
DECLARE CDECL import,bbShowEntity( BBEntity e );

DECLARE CDECL import,bbEntityParent( BBEntity e,OPT BBEntity p=0,OPT int iglobal=1 );

DECLARE CDECL import,bbCountChildren( BBEntity e ),int;
DECLARE CDECL import,bbGetChild( BBEntity e,int index ),BBEntity;
DECLARE CDECL import,bbFindChild( BBEntity e, char *t ),BBEntity;

// animation commands

DECLARE CDECL import,bbLoadAnimSeq( BBObject o, char *f ),int;
DECLARE CDECL import,bbSetAnimTime( BBObject o,float time,int seq );

DECLARE CDECL import,bbAnimate( BBObject o,OPT int mode=1,OPT float speed=1.0f,OPT int seq=0,OPT float trans=0.0f );
DECLARE CDECL import,bbSetAnimKey( BBObject o,int frame,OPT int pos_key=1,OPT int rot_key=1,OPT int scl_key=1 );

DECLARE CDECL import,bbExtractAnimSeq( BBObject o,int first,int last,int seq ),int;
DECLARE CDECL import,bbAddAnimSeq( BBObject o,int length ),int;
DECLARE CDECL import,bbAnimSeq( BBObject o ),int;
DECLARE CDECL import,bbAnimTime( BBObject o ),float;
DECLARE CDECL import,bbAnimLength( BBObject o ),int;
DECLARE CDECL import,bbAnimating( BBObject o ),int;

// entity special fx commands

DECLARE CDECL import,bbPaintEntity( BBEntity e,BBBrush b );
DECLARE CDECL import,bbEntityColor( BBModel m,float r,float g,float b );
DECLARE CDECL import,bbEntityAlpha( BBModel m,float alpha );
DECLARE CDECL import,bbEntityShininess( BBModel m,float shininess );

DECLARE CDECL import,bbEntityTexture( BBModel m,BBTexture t,OPT int frame=0,OPT int index=0 );

DECLARE CDECL import,bbEntityBlend( BBModel m,int blend );
DECLARE CDECL import,bbEntityFX( BBModel m,int fx );
DECLARE CDECL import,bbEntityAutoFade( BBModel m,float nr,float fr );
DECLARE CDECL import,bbEntityOrder( BBObject o,int n );

// entity property commands


DECLARE CDECL import,bbEntityX( BBEntity e,OPT int iglobal=0 ),float;
DECLARE CDECL import,bbEntityY( BBEntity e,OPT int iglobal=0 ),float;
DECLARE CDECL import,bbEntityZ( BBEntity e,OPT int iglobal=0 ),float;
DECLARE CDECL import,bbEntityPitch( BBEntity e,OPT int iglobal=0 ),float;
DECLARE CDECL import,bbEntityYaw( BBEntity e,OPT int iglobal=0 ),float;
DECLARE CDECL import,bbEntityRoll( BBEntity e,OPT int iglobal=0 ),float;

DECLARE CDECL import,bbGetMatElement( BBEntity e,int row,int col ),float;
DECLARE CDECL import,bbTFormPoint( float x,float y,float z,BBEntity src,BBEntity dest );
DECLARE CDECL import,bbTFormVector( float x,float y,float z,BBEntity src,BBEntity dest );
DECLARE CDECL import,bbTFormNormal( float x,float y,float z,BBEntity src,BBEntity dest );
DECLARE CDECL import,bbTFormedX(),float;
DECLARE CDECL import,bbTFormedY(),float;
DECLARE CDECL import,bbTFormedZ(),float;
DECLARE CDECL import,bbVectorYaw( float x,float y,float z ),float;
DECLARE CDECL import,bbVectorPitch( float x,float y,float z ),float;
DECLARE CDECL import,bbDeltaYaw( BBEntity src,BBEntity dest ),float;
DECLARE CDECL import,bbDeltaPitch( BBEntity src,BBEntity dest ),float;

// entity collision commands

DECLARE CDECL import,bbResetEntity( BBObject o );
DECLARE CDECL import,bbCaptureEntity( BBObject o );

DECLARE CDECL import,bbEntityType( BBObject o,int type,OPT int recurs=0 );

DECLARE CDECL import,bbEntityPickMode( BBObject o,int mode,int obs );
DECLARE CDECL import,bbGetParent( BBEntity e ),BBEntity;
DECLARE CDECL import,bbGetEntityType( BBObject o ),int;

DECLARE CDECL import,bbEntityRadius( BBObject o,float x_radius,OPT float y_radius=0.0f );

DECLARE CDECL import,bbEntityBox( BBObject o,float x,float y,float z,float w,float h,float d );
DECLARE CDECL import,bbEntityCollided( BBObject o,int type ),BBObject;
DECLARE CDECL import,bbCountCollisions( BBObject o ),int;
DECLARE CDECL import,bbCollisionX( BBObject o,int index ),float;
DECLARE CDECL import,bbCollisionY( BBObject o,int index ),float;
DECLARE CDECL import,bbCollisionZ( BBObject o,int index ),float;
DECLARE CDECL import,bbCollisionNX( BBObject o,int index ),float;
DECLARE CDECL import,bbCollisionNY( BBObject o,int index ),float;
DECLARE CDECL import,bbCollisionNZ( BBObject o,int index ),float;
DECLARE CDECL import,bbCollisionTime( BBObject o,int index ),float;
DECLARE CDECL import,bbCollisionEntity( BBObject o,int index ),BBObject;
DECLARE CDECL import,bbCollisionSurface( BBObject o,int index ),BBSurface;
DECLARE CDECL import,bbCollisionTriangle( BBObject o,int index ),int;
DECLARE CDECL import,bbEntityDistance( BBEntity src,BBEntity dest ),float;

// entity transformation commands

DECLARE CDECL import,bbMoveEntity( BBEntity e,float x,float y,float z );

DECLARE CDECL import,bbTurnEntity( BBEntity e,float p,float y,float r,OPT int iglobal=0 );
DECLARE CDECL import,bbTranslateEntity( BBEntity e,float x,float y,float z,OPT int iglobal=0 );
DECLARE CDECL import,bbPositionEntity( BBEntity e,float x,float y,float z,OPT int iglobal=0 );
DECLARE CDECL import,bbScaleEntity( BBEntity e,float x,float y,float z,OPT int iglobal=0 );
DECLARE CDECL import,bbRotateEntity( BBEntity e,float p,float y,float r,OPT int iglobal=0 );
DECLARE CDECL import,bbPointEntity( BBEntity e,BBEntity t,OPT float roll=0 );

DECLARE CDECL import,bbAlignToVector( BBEntity e,float nx,float ny,float nz,int axis,float rate );

// entity misc commands

DECLARE CDECL import,bbNameEntity( BBEntity e, char *t );
DECLARE CDECL import,bbEntityName( BBEntity e ),char*;
DECLARE CDECL import,bbEntityClass( BBEntity e ),char*;
DECLARE CDECL import,bbClearWorld( int e,int b,int t );
DECLARE CDECL import,bbSetEntityID( BBEntity *e,int id );
DECLARE CDECL import,bbEntityID( BBEntity *e ),int;

DECLARE CDECL import,bbActiveTextures(),int;
